"use strict";
var TsConfigLoader = require("./tsconfig-loader");
var path = require("path");
function configLoader(_a) {
    var _b = _a.tsConfigLoader, tsConfigLoader = _b === void 0 ? TsConfigLoader.tsConfigLoader : _b, explicitParams = _a.explicitParams, cwd = _a.cwd;
    if (explicitParams) {
        var absoluteBaseUrl_1 = path.isAbsolute(explicitParams.baseUrl)
            ? explicitParams.baseUrl
            : path.join(cwd, explicitParams.baseUrl);
        return {
            absoluteBaseUrl: absoluteBaseUrl_1,
            paths: explicitParams.paths
        };
    }
    // Load tsconfig and create path matching function
    var loadResult = tsConfigLoader({
        cwd: cwd,
        getEnv: function (key) { return process.env[key]; },
    });
    if (!loadResult.tsConfigPath) {
        throw new Error("Couldn't find tsconfig");
    }
    var tsConfigDir = path.dirname(loadResult.tsConfigPath);
    var absoluteBaseUrl = path.join(tsConfigDir, loadResult.baseUrl);
    return {
        absoluteBaseUrl: absoluteBaseUrl,
        paths: loadResult.paths
    };
}
exports.configLoader = configLoader;
